import casadi.*

% This time we are using casadi without the opti environment Opti()
% therefore we declare a symbolic casadi variable like this
u  = SX.sym('u',param.N);

% build the Phi expression here
% i.e. an expression that depends on the symbolic variable U
% you can start from param.x0 and then modify this until you
% have expressed the complete Phi
Phi_expr = param.x0;
Phi_expr = Phi_expr + ...
    
... TODO: Build expression for phi using the symbolic U


% After having build Phi_expr we use it to declare a casadi function
% the function will return both the function value and its jacobian
% this function can be evaluated as
% [F, J] = Phi_casadi(u_test)
Phi_casadi = Function('Phi',{u},{Phi_expr, jacobian(Phi_expr,u)});

% by default a casadi function returns a casadi matrix.
% this will not work as input to a general Matlab function,
% so we have to change its return type
Phi_casadi = returntypes('full',Phi_casadi);

% If we would not change the output type like this, we could still do it
% manually using full(). i.e. the above is equivalent to
% [F, J] = Phi_casadi(u_test)
% F = full(F)
% J = full(J)
% where F and J are now normal Matlab matrices